package com.steerinfo.meterwork.meterworkonline.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.meterwork.except.MarkerMetException;
import com.steerinfo.meterwork.meterworkonline.model.MeterWorkOnline;
import com.steerinfo.meterwork.meterworkonline.service.IMeterWorkOnlineService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * MeterWorkOnline RESTful接口：
 *
 * @author generator
 * @version 1.0-SNAPSHORT 2020-11-10 02:50
 * 类描述
 * 修订历史：
 * 日期：2020-11-10
 * 作者：generator
 * 参考：
 * 描述：MeterWorkOnline RESTful接口
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 * @see null
 */
@RestController
@RequestMapping("/${api.version}/meterworkonlines")
public class MeterWorkOnlineController extends BaseRESTfulController {

    @Autowired
    IMeterWorkOnlineService meterWorkOnlineService;

    @ApiOperation(value = "获取列表", notes = "分页查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkonline:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkOnline> list = meterWorkOnlineService.queryForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取列表", notes = "分页模糊查询")
    @ApiImplicitParams({
            @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
            @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("meterworkonline:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas, Integer pageNum, Integer pageSize) {
        try {
            PageList<MeterWorkOnline> list = meterWorkOnlineService.queryLikeForPage(parmas, pageNum, pageSize);
            return success(list);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "创建", notes = "根据MeterWorkOnline对象创建")
    @ApiImplicitParam(name = "meterWorkOnline", value = "详细实体meterWorkOnline", required = true, dataType = "MeterWorkOnline")
    //@RequiresPermissions("meterworkonline:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute MeterWorkOnline model) {
        try {
            MeterWorkOnline meterWorkOnline = meterWorkOnlineService.add(model);
            return success(meterWorkOnline);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "获取详细信息", notes = "根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkonline:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable String id) {
        try {
            MeterWorkOnline meterWorkOnline = meterWorkOnlineService.getById(id);
            return success(meterWorkOnline);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "更新详细信息", notes = "根据url的id来指定更新对象，并根据传过来的meterWorkOnline信息来更新详细信息")
    @ApiImplicitParams({
            @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String"),
            @ApiImplicitParam(name = "meterWorkOnline", value = "详细实体meterWorkOnline", required = true, dataType = "MeterWorkOnline")
    })
    //@RequiresPermissions("meterworkonline:update")
    @PutMapping(value = "/{id}", produces = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable String id, @RequestBody MeterWorkOnline model) {
        try {
            model.setId(id);
            MeterWorkOnline meterWorkOnline = meterWorkOnlineService.modify(model);
            return success(meterWorkOnline);
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }

    @ApiOperation(value = "删除", notes = "根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "String")
    //@RequiresPermissions("meterworkonline:delete")
    @DeleteMapping(value = "/{id}")//String
    public RESTfulResult delete(@PathVariable String id) {
        try {
            List<String> list = Arrays.asList(id.split(","));
            if (ListUtils.isNotEmpty(list)) {
                List<String> ids = ListUtils.convertList(list);
                meterWorkOnlineService.delete(ids);
            }
            return success();
        } catch (Exception ex) {
           ex.printStackTrace();
throw new MarkerMetException(500, "操作异常！！");
        }
    }


    @ApiOperation(value = "创建", notes = "根据MeterWorkOnline对象创建")
    @ApiImplicitParam(name = "meterWorkOnline", value = "详细实体meterWorkOnline", required = true, dataType = "MeterWorkOnline")
    //@RequiresPermissions("meterworkonline:create")
    @PostMapping(value = "/doSaveWf")
    public RESTfulResult doSaveWf(@RequestBody MeterWorkOnline model) {
        RESTfulResult rm = failed();
        try {
            int num = meterWorkOnlineService.doSaveWf(model);
            if (num >= 1) {
                return success(num);
            } else {
                return failed("新增失败");
            }
        } catch (Exception e) {
            e.printStackTrace();
            rm.setMessage("操作异常，请确认！");
        } finally {

        }
        return rm;
    }

}
